module basic.Attribute;

import tango.core.BitManip;
import Integer = tango.text.convert.Integer;

import tango.io.Stdout;

enum Protection : uint
{
    Private   = 1<<0,
    Public    = 1<<1,
    Package   = 1<<2,
    Protected = 1<<3,
    Export    = 1<<4,
}

struct Attribute
{

    void setProtection(Protection p)
    {
        att &= 0xFFFFFFE0;
        att |= p;
    }

    Protection getProtection()
    {
        Protection p = Protection.Public;
        switch(bsf(0xF0000000 | att))
        {
            case 0:
                p = Protection.Private;
                break;
            case 1:
                p = Protection.Public;
                break;
            case 2:
                p = Protection.Package;
                break;
            case 3:
                p = Protection.Protected;
                break;
            case 4:
                p = Protection.Export;
                break;
            default:
                break;
        }
        return p;
    }

    void setStatic()    { att &= ~Static; }
    void setFinal()     { att &= ~Final; }
    void setConst()     { att &= ~Const; }
    void setAbstract()  { att &= ~Abstract; }
    void setOverride()  { att &= ~Override; }
    void setDepracted() { att &= ~Depracted; }
    void setAuto()      { att &= ~Auto; }

    char[] toString()
    {
        return Integer.toString(att);
    }

private:
    uint att;


    static const uint Static        = 1<<5;
    static const uint Final         = 1<<6;
    static const uint Const         = 1<<7;
    static const uint Abstract      = 1<<8;
    static const uint Override      = 1<<9;
    static const uint Depracted     = 1<<10;
    static const uint Auto          = 1<<11;
}
